## dlm 0.7-1

=== DESCRIPTION ===
Package: dlm
Title: Functions for DLM Analysis
Version: 0.7-1
Date: 2006-08-22
Author: Giovanni Petris
Description: Maximum likelihood and Bayesian analysis
  of Dynamic Linear Models 
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (version 2 or later)
Packaged: Fri Aug 25 10:12:24 2006; hornik

## dlm 0.8-1

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 0.8-1
Date: 2007-11-14
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and Bayesian
  analysis of Normal linear State Space models, also known as 
  Dynamic Linear Models 
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (version 2 or later)
Packaged: Mon Nov 19 10:31:32 2007; gpetris

## dlm 0.9-1

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 0.9-1
Date: 2008-05-30
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and Bayesian
  analysis of Normal linear State Space models, also known as 
  Dynamic Linear Models 
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: Fri May 30 11:32:53 2008; gpetris

## dlm 0.99-0

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 0.99-0
Date: 2009-01-14
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and Bayesian
  analysis of Normal linear State Space models, also known as 
  Dynamic Linear Models 
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: Wed Jan 14 11:34:26 2009; gpetris

## dlm 0.trunk20040913

=== lib/Makefile ===
###############################################################################
###############################################################################
##
##  Copyright (C) Sistina Software, Inc.  1997-2004  All rights reserved.
##  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
##  
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
STATICLIB=libdlm.a

SOURCE=libdlm.c

LIBNAME=libdlm
SHAREDLIB=$(LIBNAME).so.${RELEASE_MAJOR}.${RELEASE_MINOR}

top_srcdir=..
UNINSTALL=${top_srcdir}/scripts/uninstall.pl

include ${top_srcdir}/make/defines.mk

CFLAGS += -g -O -D_REENTRANT -fpic -I.

ifneq (${KERNEL_SRC}, )
# Use the kernel tree if patched, otherwise, look where cluster headers
#  should be installed
CFLAGS += $(shell if [ -d ${KERNEL_SRC}/include/cluster ]; then \
		echo '-I${KERNEL_SRC}/include/cluster'; else \
		echo '-I${incdir}/cluster'; fi)
else
CFLAGS += -I${incdir}/cluster
endif


all: $(STATICLIB) $(SHAREDLIB)

$(LIBNAME).a: libdlm.o
	${AR} r libdlm.a libdlm.o
	${RANLIB} libdlm.a 

$(LIBNAME).so.${RELEASE_MAJOR}.${RELEASE_MINOR}: libdlm.po
	$(CC) -shared -o $@ -Wl,-soname=$(LIBNAME).so.$(RELEASE_MAJOR) $^

libdlm.po: libdlm.c
	$(CC) $(CFLAGS) -fPIC -c -o $@ $<

copytobin: all


install: all
	install -d ${incdir}
	install libdlm.h ${incdir}
	install -d ${libdir}
	install $(LIBNAME).a ${libdir}
	install $(LIBNAME).so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}
	ln -sf $(LIBNAME).so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}/$(LIBNAME).so
	ln -sf $(LIBNAME).so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}/$(LIBNAME).so.$(RELEASE_MAJOR)

uninstall:
	${UNINSTALL} libdlm.h ${incdir}
	${UNINSTALL} \
		${LIBNAME}.a \
		$(LIBNAME).so \
		$(LIBNAME).so.$(RELEASE_MAJOR) \
		${LIBNAME}.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}
	rm -f /lib/${LIBNAME}.*

clean:
	rm -f *.o *.a *.so *.so.* *.po
	rm -f *~

=== tests/usertest/Makefile ===
###############################################################################
###############################################################################
##
##  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
top_srcdir = ../../..
UNINSTALL=${top_srcdir}/scripts/uninstall.pl

BINARIES=dlmtest asttest lstest

all: $(BINARIES)

CFLAGS+=-I${top_srcdir}/dlm/lib -L${top_srcdir}/dlm/lib -g -D_REENTRANT

ifneq (${KERNEL_SRC}, )
CFLAGS += -I${KERNEL_SRC}/include/cluster
else
CFLAGS += -I/usr/include/linux/cluster
endif


dlmtest: dlmtest.c
	$(CC) $(CFLAGS) -o $@ $< -ldlm -lpthread

asttest: asttest.c
	$(CC) $(CFLAGS) -o $@ $< -ldlm -lpthread

lstest: lstest.c
	$(CC) $(CFLAGS) -o $@ $< -ldlm -lpthread

clean:
	rm -f *.o $(BINARIES) *~ core

copytobin:

## dlm 0.trunk20050206

=== lib/Makefile ===
--- 
+++ 
@@ -10,19 +10,19 @@
 ##
 ###############################################################################
 ###############################################################################
-STATICLIB=libdlm.a
 
-SOURCE=libdlm.c
+SOURCE=libdlm.c libaislock.c
 
 LIBNAME=libdlm
-SHAREDLIB=$(LIBNAME).so.${RELEASE_MAJOR}.${RELEASE_MINOR}
+SHAREDLIB=$(LIBNAME).so.${RELEASE_MAJOR}.${RELEASE_MINOR} $(LIBNAME)_lt.so.${RELEASE_MAJOR}.${RELEASE_MINOR}
+STATICLIB=$(LIBNAME).a $(LIBNAME)_lt.a
 
 top_srcdir=..
 UNINSTALL=${top_srcdir}/scripts/uninstall.pl
 
 include ${top_srcdir}/make/defines.mk
 
-CFLAGS += -g -O -D_REENTRANT -fpic -I.
+CFLAGS += -g -O -I. -fPIC
 
 ifneq (${KERNEL_SRC}, )
 # Use the kernel tree if patched, otherwise, look where cluster headers
@@ -37,15 +37,37 @@
 
 all: $(STATICLIB) $(SHAREDLIB)
 
-$(LIBNAME).a: libdlm.o
-	${AR} r libdlm.a libdlm.o
+$(LIBNAME).a: libdlm.o libaislock.o
+	${AR} cr libdlm.a libdlm.o libaislock.o
 	${RANLIB} libdlm.a 
 
-$(LIBNAME).so.${RELEASE_MAJOR}.${RELEASE_MINOR}: libdlm.po
-	$(CC) -shared -o $@ -Wl,-soname=$(LIBNAME).so.$(RELEASE_MAJOR) $^
+$(LIBNAME)_lt.a: libdlm_lt.o 
+	${AR} r libdlm_lt.a libdlm_lt.o 
+	${RANLIB} libdlm_lt.a 
+
+$(LIBNAME).so.${RELEASE_MAJOR}.${RELEASE_MINOR}: libdlm.po libaislock.po
+	$(LD) -shared -o $@ -soname=$(LIBNAME).so.$(RELEASE_MAJOR) $^
+
+$(LIBNAME)_lt.so.${RELEASE_MAJOR}.${RELEASE_MINOR}: libdlm_lt.po
+	$(CC) -shared -o $@ -Wl,-soname=$(LIBNAME)_lt.so.$(RELEASE_MAJOR) $^
 
 libdlm.po: libdlm.c
-	$(CC) $(CFLAGS) -fPIC -c -o $@ $<
+	$(CC) $(CFLAGS) -D_REENTRANT -c -o $@ $<
+
+libdlm.o: libdlm.c
+	$(CC) $(CFLAGS) -D_REENTRANT -c -o $@ $<
+
+libaislock.po: libaislock.c
+	$(CC) $(CFLAGS) -D_REENTRANT -c -o $@ $<
+
+libaislock.o: libaislock.c
+	$(CC) $(CFLAGS) -D_REENTRANT -c -o $@ $<
+
+libdlm_lt.po: libdlm.c
+	$(CC) $(CFLAGS) -c -o $@ $<
+
+libdlm_lt.o: libdlm.c
+	$(CC) $(CFLAGS) -c -o $@ $<
 
 copytobin: all
 
@@ -55,17 +77,25 @@
 	install libdlm.h ${incdir}
 	install -d ${libdir}
 	install $(LIBNAME).a ${libdir}
+	install $(LIBNAME)_lt.a ${libdir}
 	install $(LIBNAME).so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}
+	install $(LIBNAME)_lt.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}
 	ln -sf $(LIBNAME).so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}/$(LIBNAME).so
 	ln -sf $(LIBNAME).so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}/$(LIBNAME).so.$(RELEASE_MAJOR)
+	ln -sf $(LIBNAME)_lt.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}/$(LIBNAME)_lt.so
+	ln -sf $(LIBNAME)_lt.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}/$(LIBNAME)_lt.so.$(RELEASE_MAJOR)
 
 uninstall:
 	${UNINSTALL} libdlm.h ${incdir}
 	${UNINSTALL} \
 		${LIBNAME}.a \
+		${LIBNAME}_lt.a \
 		$(LIBNAME).so \
+		$(LIBNAME)_lt.so \
 		$(LIBNAME).so.$(RELEASE_MAJOR) \
-		${LIBNAME}.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}
+		${LIBNAME}.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir} \
+		$(LIBNAME)_lt.so.$(RELEASE_MAJOR) \
+		${LIBNAME}_lt.so.$(RELEASE_MAJOR).$(RELEASE_MINOR) ${libdir}
 	rm -f /lib/${LIBNAME}.*
 
 clean:

## dlm 1.0-0

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.0-0
Date: 2009-04-15
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and
        Bayesian analysis of Normal linear State Space models, also
        known as Dynamic Linear Models
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: Wed Apr 15 12:44:06 2009; gpetris
Repository: CRAN
Date/Publication: 2009-04-15 18:13:23

## dlm 1.0-1

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.0-1
Date: 2009-05-25
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and
        Bayesian analysis of Normal linear State Space models, also
        known as Dynamic Linear Models
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: 2009-05-27 10:25:49 UTC; gpetris
Repository: CRAN
Date/Publication: 2009-05-27 12:12:25

## dlm 1.0-2

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.0-2
Date: 2009-06-12
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and
        Bayesian analysis of Normal linear State Space models, also
        known as Dynamic Linear Models
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: 2009-06-14 14:27:00 UTC; gpetris
Repository: CRAN
Date/Publication: 2009-06-16 15:21:22

## dlm 1.1-0

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.1-0
Date: 2010-02-15
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and
        Bayesian analysis of Normal linear State Space models, also
        known as Dynamic Linear Models
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: 2010-02-15 18:19:44 UTC; gpetris
Repository: CRAN
Date/Publication: 2010-02-15 19:36:19

## dlm 1.1-1

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.1-1
Date: 2010-03-25
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and
        Bayesian analysis of Normal linear State Space models, also
        known as Dynamic Linear Models
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: 2010-04-13 17:04:11 UTC; gpetris
Repository: CRAN
Date/Publication: 2010-04-13 17:26:09

## dlm 1.1-2

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.1-2
Date: 2010-10-05
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>
Description: Maximum likelihood, Kalman filtering and smoothing, and
        Bayesian analysis of Normal linear State Space models, also
        known as Dynamic Linear Models
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: 2010-10-05 14:11:09 UTC; gpetris
Repository: CRAN
Date/Publication: 2010-10-05 16:59:30

## dlm 1.1-3

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.1-3
Date: 2013-03-26
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>.  Original C code for ARMS
        by Wally Gilks.
Description: Maximum likelihood, Kalman filtering and smoothing, and
        Bayesian analysis of Normal linear State Space models, also
        known as Dynamic Linear Models
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: 2013-03-26 15:23:04 UTC; gpetris
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2013-03-26 17:55:15

## dlm 1.1-4

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.1-4
Date: 2014-09-16
Suggests: MASS
Author: Giovanni Petris <GPetris@uark.edu>.
  Original C code for ARMS by Wally Gilks.
Description: Maximum likelihood, Kalman filtering and smoothing, and Bayesian
  analysis of Normal linear State Space models, also known as 
  Dynamic Linear Models 
Maintainer: Giovanni Petris <GPetris@uark.edu>
License: GPL (>= 2)
Packaged: 2014-09-16 17:17:15 UTC; gpetris
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2014-09-16 23:53:05

## dlm 1.1-5

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.1-5
Date: 2018-05-30
Suggests: MASS
Imports: stats, utils, methods, grDevices, graphics
Authors@R: c(
    person("Giovanni", "Petris", email = "GPetris@uark.edu", role = c("aut", "cre")),
    person("Wally", "Gilks", role = "ctb", comment = "Author of original C code for ARMS"))
Description: Provides routines for Maximum likelihood,
    Kalman filtering and smoothing, and Bayesian
    analysis of Normal linear State Space models, also known as 
    Dynamic Linear Models. 
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2018-06-13 15:31:19 UTC; gpetris
Author: Giovanni Petris [aut, cre],
  Wally Gilks [ctb] (Author of original C code for ARMS)
Maintainer: Giovanni Petris <GPetris@uark.edu>
Repository: CRAN
Date/Publication: 2018-06-13 19:16:46 UTC

## dlm 1.1-6

=== DESCRIPTION ===
Package: dlm
Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
Version: 1.1-6
Date: 2022-11-12
Suggests: MASS
Imports: stats, utils, methods, grDevices, graphics
Authors@R: c(
    person("Giovanni", "Petris", email = "GPetris@uark.edu", role = c("aut", "cre")),
    person("Wally", "Gilks", role = "ctb", comment = "Author of original C code for ARMS"))
Maintainer: Giovanni Petris <GPetris@uark.edu>
Description: Provides routines for Maximum likelihood,
    Kalman filtering and smoothing, and Bayesian
    analysis of Normal linear State Space models, also known as 
    Dynamic Linear Models. 
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2022-11-25 20:09:08 UTC; gpetris
Author: Giovanni Petris [aut, cre],
  Wally Gilks [ctb] (Author of original C code for ARMS)
Repository: CRAN
Date/Publication: 2022-11-28 09:50:04 UTC

## dlm 1.1-6.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: dlm
 Title: Bayesian and Likelihood Analysis of Dynamic Linear Models
-Version: 1.1-6
+Version: 1.1-6.1
 Date: 2022-11-12
 Suggests: MASS
 Imports: stats, utils, methods, grDevices, graphics
@@ -14,8 +14,8 @@
     Dynamic Linear Models. 
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2022-11-25 20:09:08 UTC; gpetris
+Packaged: 2024-09-21 08:09:52 UTC; hornik
 Author: Giovanni Petris [aut, cre],
   Wally Gilks [ctb] (Author of original C code for ARMS)
 Repository: CRAN
-Date/Publication: 2022-11-28 09:50:04 UTC
+Date/Publication: 2024-09-21 08:15:41 UTC

## dlm 4.0.1

=== Makefile ===
all:
	make -C libdlm $@
	make -C dlm_controld $@
	make -C dlm_tool $@

install:
	make -C libdlm $@
	make -C dlm_controld $@
	make -C dlm_tool $@

clean:
	make -C libdlm $@
	make -C dlm_controld $@
	make -C dlm_tool $@

=== dlm_controld/Makefile ===
DESTDIR=
PREFIX=/usr
LIBNUM=/lib64
BINDIR=$(PREFIX)/sbin
LIBDIR=$(PREFIX)/$(LIBNUM)
HDRDIR=$(PREFIX)/include 
MANDIR=$(PREFIX)/share/man

USE_SD_NOTIFY=yes

BIN_TARGET = dlm_controld

LIB_NAME = libdlmcontrol
LIB_MAJOR = 3
LIB_MINOR = 1
LIB_SO = $(LIB_NAME).so
LIB_SMAJOR = $(LIB_SO).$(LIB_MAJOR)
LIB_TARGET = $(LIB_SO).$(LIB_MAJOR).$(LIB_MINOR)

BIN_SOURCE = action.c \
             cpg.c \
             daemon_cpg.c \
             crc.c \
             fence_config.c \
             fence.c \
             main.c \
             plock.c \
             config.c \
             member.c \
             logging.c \
             rbtree.c
LIB_SOURCE = lib.c

BIN_CFLAGS += -D_GNU_SOURCE -O2 -ggdb \
	-Wall \
	-Wformat \
	-Wformat-security \
	-Wmissing-prototypes \
	-Wnested-externs \
	-Wpointer-arith \
	-Wextra -Wshadow \
	-Wcast-align \
	-Wwrite-strings \
	-Waggregate-return \
	-Wstrict-prototypes \
	-Winline \
	-Wredundant-decls \
	-Wno-sign-compare \
	-Wno-unused-parameter \
	-Wp,-D_FORTIFY_SOURCE=2 \
	-fexceptions \
	-fasynchronous-unwind-tables \
	-fdiagnostics-show-option \

BIN_CFLAGS += -fPIE -DPIE
BIN_CFLAGS += -I../include -I../libdlm

BIN_LDFLAGS += -Wl,-z,now -Wl,-z,relro -pie
BIN_LDFLAGS += -lpthread -lrt -lcpg -lcmap -lcfg -lquorum

LIB_CFLAGS += $(BIN_CFLAGS)
LIB_LDFLAGS += -Wl,-z,relro -pie

ifeq ($(USE_SD_NOTIFY),yes)
	BIN_CFLAGS += $(shell pkg-config --cflags libsystemd-daemon) \
		      -DUSE_SD_NOTIFY
	BIN_LDFLAGS += $(shell pkg-config --libs libsystemd-daemon)
endif

all: $(LIB_TARGET) $(BIN_TARGET)

$(BIN_TARGET): $(BIN_SOURCE)
	$(CC) $(BIN_SOURCE) $(BIN_CFLAGS) $(BIN_LDFLAGS) -o $@ -L.

$(LIB_TARGET): $(LIB_SOURCE)
	$(CC) $^ $(LIB_CFLAGS) $(LIB_LDFLAGS) -shared -fPIC -o $@ -Wl,-soname=$(LIB_SMAJOR)
	ln -sf $(LIB_TARGET) $(LIB_SO)
	ln -sf $(LIB_TARGET) $(LIB_SMAJOR)

clean:
	rm -f *.o *.so *.so.* $(BIN_TARGET) $(LIB_TARGET)


INSTALL=$(shell which install)

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -d $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -d $(DESTDIR)/$(HDRDIR)
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man8
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man5
	$(INSTALL) -m 755 $(BIN_TARGET) $(DESTDIR)/$(BINDIR)
	$(INSTALL) -m 755 $(LIB_TARGET) $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_SO) $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_SMAJOR) $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -m 644 libdlmcontrol.h $(DESTDIR)/$(HDRDIR)
	$(INSTALL) -m 644 dlm_controld.8 $(DESTDIR)/$(MANDIR)/man8/
	$(INSTALL) -m 644 dlm.conf.5 $(DESTDIR)/$(MANDIR)/man5/

=== fence/Makefile ===
DESTDIR=
PREFIX=/usr
BINDIR=$(PREFIX)/sbin
#MANDIR=$(PREFIX)/share/man

BIN_TARGET = dlm_stonith
#MAN_TARGET = dlm_stonith.8

BIN_SOURCE = stonith_helper.c

BIN_CFLAGS += -D_GNU_SOURCE -O2 -ggdb \
	-Wall \
	-Wformat \
	-Wformat-security \
	-Wmissing-prototypes \
	-Wnested-externs \
	-Wpointer-arith \
	-Wextra -Wshadow \
	-Wcast-align \
	-Wwrite-strings \
	-Waggregate-return \
	-Wstrict-prototypes \
	-Winline \
	-Wredundant-decls \
	-Wno-sign-compare \
	-Wno-unused-parameter \
	-Wp,-D_FORTIFY_SOURCE=2 \
	-fexceptions \
	-fasynchronous-unwind-tables \
	-fdiagnostics-show-option \

BIN_CFLAGS += -fPIE -DPIE
BIN_CFLAGS += `xml2-config --cflags`
BIN_CFLAGS += -I../include

BIN_LDFLAGS += -Wl,-z,now -Wl,-z,relro -pie
BIN_LDFLAGS += `xml2-config --libs`
BIN_LDFLAGS += -ldl

all: $(BIN_TARGET)

$(BIN_TARGET): $(BIN_SOURCE)
	$(CC) $(BIN_SOURCE) $(BIN_CFLAGS) $(BIN_LDFLAGS) -o $@ -L.

clean:
	rm -f *.o *.so *.so.* $(BIN_TARGET)


INSTALL=$(shell which install)

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man8
	$(INSTALL) -c -m 755 $(BIN_TARGET) $(DESTDIR)/$(BINDIR)
#	$(INSTALL) -m 644 $(MAN_TARGET) $(DESTDIR)/$(MANDIR)/man8/

=== libdlm/Makefile ===
DESTDIR=
PREFIX=/usr
LIBNUM=/lib64
LIBDIR=$(PREFIX)/$(LIBNUM)
HDRDIR=$(PREFIX)/include 
MANDIR=$(PREFIX)/share/man
PKGDIR=$(LIBDIR)/pkgconfig
UDEVDIR=/lib/udev/rules.d

LIB_NAME = libdlm
LIB_MAJOR = 3
LIB_MINOR = 0
LIB_O = $(LIB_NAME).o
LIB_SO = $(LIB_NAME).so
LIB_SMAJOR = $(LIB_SO).$(LIB_MAJOR)
LIB_TARGET = $(LIB_SO).$(LIB_MAJOR).$(LIB_MINOR)
LIB_PC = $(LIB_NAME).pc
LIB_PCIN = $(LIB_NAME).pc.in

LLT_NAME = libdlm_lt
LLT_MAJOR = 3
LLT_MINOR = 0
LLT_O = $(LLT_NAME).o
LLT_SO = $(LLT_NAME).so
LLT_SMAJOR = $(LLT_SO).$(LLT_MAJOR)
LLT_TARGET = $(LLT_SO).$(LLT_MAJOR).$(LLT_MINOR)
LLT_PC = $(LLT_NAME).pc
LLT_PCIN = $(LLT_NAME).pc.in

HDR_TARGET = libdlm.h

MAN_TARGET = \
	man/dlm_cleanup.3 \
	man/dlm_close_lockspace.3 \
	man/dlm_create_lockspace.3 \
	man/dlm_dispatch.3 \
	man/dlm_get_fd.3 \
	man/dlm_lock.3 \
	man/dlm_lock_wait.3 \
	man/dlm_ls_lock.3 \
	man/dlm_ls_lock_wait.3 \
	man/dlm_ls_lockx.3 \
	man/dlm_ls_pthread_init.3 \
	man/dlm_ls_unlock.3 \
	man/dlm_ls_unlock_wait.3 \
	man/dlm_new_lockspace.3 \
	man/dlm_open_lockspace.3 \
	man/dlm_pthread_init.3 \
	man/dlm_release_lockspace.3 \
	man/dlm_unlock.3 \
	man/dlm_unlock_wait.3 \
	man/libdlm.3

UDEV_TARGET = 51-dlm.rules

SOURCE = libdlm.c

CFLAGS += -D_GNU_SOURCE -O2 -ggdb \
	-Wall \
	-Wformat \
	-Wformat-security \
	-Wmissing-prototypes \
	-Wnested-externs \
	-Wpointer-arith \
	-Wextra -Wshadow \
	-Wcast-align \
	-Wwrite-strings \
	-Waggregate-return \
	-Wstrict-prototypes \
	-Winline \
	-Wredundant-decls \
	-Wno-sign-compare \
	-Wno-unused-parameter \
	-Wp,-D_FORTIFY_SOURCE=2 \
	-fexceptions \
	-fasynchronous-unwind-tables \
	-fdiagnostics-show-option \
	-fPIC

LIB_CFLAGS += $(CFLAGS) -D_REENTRANT
LLT_CFLAGS += $(CFLAGS)

LIB_LDFLAGS += $(LDFLAGS) -lpthread
LLT_LDFLAGS += $(LDFLAGS)

all: $(LIB_TARGET) $(LLT_TARGET) $(LIB_PC) $(LLT_PC)

$(LIB_O): $(SOURCE) 
	$(CC) $< $(LIB_CFLAGS) -c -o $@

$(LLT_O): $(SOURCE) 
	$(CC) $< $(LLT_CFLAGS) -c -o $@

$(LIB_TARGET): $(LIB_O)
	$(CC) $^ $(LIB_LDFLAGS) -shared -o $@ -Wl,-soname=$(LIB_SMAJOR)
	ln -sf $(LIB_TARGET) $(LIB_SO)
	ln -sf $(LIB_TARGET) $(LIB_SMAJOR)

$(LLT_TARGET): $(LLT_O)
	$(CC) $^ $(LLT_LDFLAGS) -shared -o $@ -Wl,-soname=$(LLT_SMAJOR)
	ln -sf $(LLT_TARGET) $(LLT_SO)
	ln -sf $(LLT_TARGET) $(LLT_SMAJOR)

$(LIB_PC): $(LIB_PCIN)
	cat $(LIB_PCIN) | sed -e 's#@PREFIX@#$(PREFIX)#g' > $@

$(LLT_PC): $(LLT_PCIN)
	cat $(LIB_PCIN) | sed -e 's#@PREFIX@#$(PREFIX)#g' > $@

clean:
	rm -f *.o *.so *.so.* *.a *.pc

INSTALL=$(shell which install)

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -d $(DESTDIR)/$(HDRDIR)
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man3
	$(INSTALL) -d $(DESTDIR)/$(PKGDIR)
	$(INSTALL) -d $(DESTDIR)/$(UDEVDIR)
	$(INSTALL) -c -m 755 $(LIB_TARGET) $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -c -m 755 $(LLT_TARGET) $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_SO) $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_SMAJOR) $(DESTDIR)/$(LIBDIR)
	cp -a $(LLT_SO) $(DESTDIR)/$(LIBDIR)
	cp -a $(LLT_SMAJOR) $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -m 644 $(LIB_PC) $(DESTDIR)/$(PKGDIR)
	$(INSTALL) -m 644 $(LLT_PC) $(DESTDIR)/$(PKGDIR)
	$(INSTALL) -c -m 644 $(HDR_TARGET) $(DESTDIR)/$(HDRDIR)
	$(INSTALL) -m 644 $(MAN_TARGET) $(DESTDIR)/$(MANDIR)/man3/
	$(INSTALL) -m 644 $(UDEV_TARGET) $(DESTDIR)/$(UDEVDIR)

=== debian/changelog ===
dlm (4.0.1-0ubuntu1) saucy; urgency=low

  * Initial release:
    - DLM used to be part of redhat-cluster source package. However,
      upstream made 'cluster' obsolete and separated DLM (along with
      other components) into their own projects. The binaries this
      package builds will replace some of those redhat-cluster builds.
  * debian/patches:
    - fix_lib_dir.patch: Use correct installation path.
    - fix_init_script.patch: Use $remote_fs for Required-{Start,Stop}.
    - fix_manpages.patch: Fix manpages for them to be lintian clean.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 23 Jul 2013 15:50:10 -0400

=== debian/control ===
Source: dlm
Section: admin
Priority: optional
Maintainer: Andres Rodriguez <andreserl@ubuntu.com>
Build-Depends: debhelper (>= 8.0.0), libcfg-dev, pacemaker-dev, libxml2-dev, libsystemd-daemon-dev, libqb-dev
Standards-Version: 3.9.4
Homepage: https://git.fedorahosted.org/git/dlm.git

Package: dlm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: cman
Replaces: cman
Description: DLM - Distributed lock manager binaries
 DLM is a symmetric general-purpose distributed lock manager. It is
 used for example by GFS and the distributed volume manager.
 .
 These are the binaries that interface with the lock manager.
 The lock manager itself is a kernel module.

Package: libdlm3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: udev (<< 0.136-1), libdlm3 (<= 3.1.8-1.1)
Replaces: libdlm3 (<= 3.1.8-1.1)
Description: DLM - distributed lock manager library
 DLM is a symmetric general-purpose distributed lock manager. It is
 used for example by GFS and the distributed volume manager.
 .
 This is the client library for applications using the lock manager.
 The lock manager itself is a kernel module.

Package: libdlm-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libdlm3 (= ${binary:Version})
Breaks: libdlm-dev (<= 3.1.8-1.1)
Replaces: libdlm-dev (<= 3.1.8-1.1)
Description: DLM - distributed lock manager development files
 DLM is a symmetric general-purpose distributed lock manager. It is
 used for example by GFS and the distributed volume manager.
 .
 This package contains the files needed for developing applications
 that use the lock manager.

Package: libdlmcontrol3
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libdlmcontrol3 (<= 3.1.8-1.1)
Replaces: libdlmcontrol3 (<= 3.1.8-1.1)
Description: DLM - distributed lock manager library
 DLM is a symmetric general-purpose distributed lock manager. It is
 used for example by GFS and the distributed volume manager.
 .
 This is the client library for applications using the lock manager.
 The lock manager itself is a kernel module.

Package: libdlmcontrol-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdlmcontrol3 (= ${binary:Version})
Breaks: libdlmcontrol-dev (<= 3.1.8-1.1)
Replaces: libdlmcontrol-dev (<= 3.1.8-1.1)
Description: DLM - distributed lock manager development files
 DLM is a symmetric general-purpose distributed lock manager. It is
 used for example by GFS and the distributed volume manager.
 .
 This package contains the files needed for developing applications
 that use the lock manager.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

BUILDROOT := $(shell pwd)

%:
	dh $@ 

override_dh_install:
	install -d -m 0755 debian/tmp/lib/udev/rules.d
	mv debian/tmp/lib/udev/rules.d/51-dlm.rules debian/tmp/lib/udev/rules.d/45-dlm.rules

	cp init/dlm.init $(BUILDROOT)/debian/dlm.init

	dh_install --sourcedir=debian/tmp --list-missing

## dlm 4.0.4

=== fence/Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 DESTDIR=
 PREFIX=/usr
 BINDIR=$(PREFIX)/sbin
-#MANDIR=$(PREFIX)/share/man
+MANDIR=$(PREFIX)/share/man
 
 BIN_TARGET = dlm_stonith
-#MAN_TARGET = dlm_stonith.8
+MAN_TARGET = dlm_stonith.8
 
 BIN_SOURCE = stonith_helper.c
 
@@ -53,5 +53,5 @@
 	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
 	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man8
 	$(INSTALL) -c -m 755 $(BIN_TARGET) $(DESTDIR)/$(BINDIR)
-#	$(INSTALL) -m 644 $(MAN_TARGET) $(DESTDIR)/$(MANDIR)/man8/
+	$(INSTALL) -m 644 $(MAN_TARGET) $(DESTDIR)/$(MANDIR)/man8/

=== libdlm/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 HDRDIR=$(PREFIX)/include 
 MANDIR=$(PREFIX)/share/man
 PKGDIR=$(LIBDIR)/pkgconfig
-UDEVDIR=/lib/udev/rules.d
+UDEVDIR=/usr/lib/udev/rules.d
 
 LIB_NAME = libdlm
 LIB_MAJOR = 3
@@ -102,10 +102,10 @@
 	ln -sf $(LLT_TARGET) $(LLT_SMAJOR)
 
 $(LIB_PC): $(LIB_PCIN)
-	cat $(LIB_PCIN) | sed -e 's#@PREFIX@#$(PREFIX)#g' > $@
+	cat $(LIB_PCIN) | sed -e 's#@PREFIX@#$(PREFIX)#g;s#@LIBDIR@#$(LIBDIR)#g' > $@
 
 $(LLT_PC): $(LLT_PCIN)
-	cat $(LIB_PCIN) | sed -e 's#@PREFIX@#$(PREFIX)#g' > $@
+	cat $(LIB_PCIN) | sed -e 's#@PREFIX@#$(PREFIX)#g;s#@LIBDIR@#$(LIBDIR)#g' > $@
 
 clean:
 	rm -f *.o *.so *.so.* *.a *.pc

=== debian/changelog ===
dlm (4.0.4-3ubuntu1) xenial; urgency=medium

  * Resync with Debian unstable (LP: #1248054, #1491745); remaining changes:
    - d/control,dlm.install,rules: Rename dlm-controld -> dlm inline
      with packaging history in Ubuntu.

 -- James Page <james.page@ubuntu.com>  Tue, 08 Mar 2016 10:31:02 +0000

dlm (4.0.4-3) unstable; urgency=medium

  * [526167a] Add corosync dependency to dlm-controld (Closes: #814519)
  * [3c98ecb] Update Standards-Version to 3.9.7 (no changes needed)

 -- Ferenc Wágner <wferi@niif.hu>  Fri, 12 Feb 2016 15:11:37 +0100

dlm (4.0.4-2) unstable; urgency=medium

  * [a10e0c9] New patch Build-reproducibly-don-t-compile-in-the-build-time.patch
  * [dda5591] Replace obsolete libsystemd-daemon-dev B-D with libsystemd-dev
    (Closes: #813376)
  * [12b55a9] Switch to secure VCS URIs as Lintian suggests
  * [562bd20] New patch Enable-bindnow-for-libdlmcontrol.patch

 -- Ferenc Wágner <wferi@niif.hu>  Tue, 02 Feb 2016 11:35:06 +0100

dlm (4.0.4-1) unstable; urgency=medium

  * [0c99a79] Imported Upstream version 4.0.4
  * [619a537] Avoid useless libxml2 dependency of dlm-controld
  * [203aa46] debian/watch: look for tar.xz instead of tar.gz
  * [0ce96d5] Delete upstreamed patches, update the remaining one
  * [6a30ac3] Upstream udev dir is under /usr/lib since 102d3c2
  * [d655c87] Taking over dlm_{controld,tool} requires Breaks+Replaces cman
    (Closes: #812419)
  * [a7b3406] Hardening seems to work now, enable it

 -- Ferenc Wágner <wferi@niif.hu>  Sat, 23 Jan 2016 21:21:28 +0100

dlm (4.0.2-1) unstable; urgency=medium

  [ Ferenc Wágner ]
  * [eb5910d] Switch to the new DLM upstream from redhat-cluster and redo
    packaging
  * [1bdc449] Add symbols file for libdlmcontrol3
  * [ce903ed] Force building with Corosync 2 libraries
  * [f0cc3b2] Build and ship the dlm_stonith helper
  * [03ccd41] New patch Make-systemd-stop-dlm-on-corosync-restart.patch
  * [3127527] New patch If-an-error-occurs-unlink-the-lock-file-and-exit-
    wit.patch
  * [05e959e] New patch Don-t-SIGKILL-dlm_controld.patch
  * [61adabd] Ensure configfs is loaded before sys-kernel-config.mount needs it

  [ Christoph Berg ]
  * Rely on dh for -dbgsym packages instead of providing our own.
  * Add watch file.

 -- Christoph Berg <myon@debian.org>  Mon, 04 Jan 2016 23:38:06 +0100

=== debian/control ===
Source: dlm
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian HA Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
Uploaders: Ferenc Wágner <wferi@niif.hu>,
 Christoph Berg <myon@debian.org>
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9),
 dh-systemd,
 libcfg-dev (>= 1.99),
 libcpg-dev (>= 1.99),
 libcmap-dev (>= 1.99),
 libquorum-dev (>= 1.99),
 libsystemd-dev,
 libstonithd-dev,
 libxml2-dev,
 pkg-config
Homepage: https://fedorahosted.org/cluster/wiki/HomePage
Vcs-Git: https://anonscm.debian.org/git/debian-ha/dlm.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-ha/dlm.git/

Package: dlm
Architecture: any
Depends:
 corosync,
 ${misc:Depends},
 ${shlibs:Depends},
# we're taking over /usr/sbin/dlm_{controld,tool}
Breaks:
 cman,
Replaces:
 cman,
Description: Distributed Lock Manager control daemon
 DLM is a symmetric general-purpose distributed lock manager.
 The lock manager itself is a kernel module.
 .
 This package contains the control daemon and utility.

Package: libdlm3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Distributed Lock Manager library
 DLM is a symmetric general-purpose distributed lock manager.
 The lock manager itself is a kernel module.
 .
 This is the client library for applications using the lock manager.

Package: libdlm-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libdlm3 (= ${binary:Version})
Description: Distributed Lock Manager library development
 DLM is a symmetric general-purpose distributed lock manager.
 The lock manager itself is a kernel module.
 .
 This package contains the headers and other necessary files to build
 applications or libraries that use the DLM library.

Package: libdlmcontrol3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Distributed Lock Manager control library
 DLM is a symmetric general-purpose distributed lock manager.
 The lock manager itself is a kernel module.
 .
 This is the client library for applications using the lock manager daemon?

Package: libdlmcontrol-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libdlmcontrol3 (= ${binary:Version})
Description: Distributed Lock Manager control library development
 DLM is a symmetric general-purpose distributed lock manager.
 The lock manager itself is a kernel module.
 .
 This package contains the headers and other necessary files to build
 applications or libraries that use the DLM control library.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Ensure that we link against all needed libraries (cf. Policy 10.2)
export DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,defs

# Avoid useless dependencies in the utilities
export DEB_LDFLAGS_MAINT_APPEND+=-Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with systemd

override_dh_auto_install:
	dh_auto_install -- LIBNUM=/lib/$(DEB_HOST_MULTIARCH)

DEFDIR=debian/dlm/etc/default
SDDIR= debian/dlm/lib/systemd/system
override_dh_install:
	dh_install --fail-missing
	mkdir -p "$(DEFDIR)" "$(SDDIR)"
	cp init/dlm.sysconfig "$(DEFDIR)"/dlm
	cp init/dlm.service "$(SDDIR)"

=== debian/watch ===
version=3
https://git.fedorahosted.org/git/dlm.git .*/dlm-(.*).tar.xz

## dlm 4.0.6

=== debian/changelog ===
dlm (4.0.6-1) unstable; urgency=medium

  * [3805ad8] New upstream release (4.0.6)

 -- Ferenc Wágner <wferi@niif.hu>  Fri, 24 Jun 2016 12:54:01 +0200

dlm (4.0.5-1) unstable; urgency=medium

  * [9945090] Imported Upstream version 4.0.5
    - Fix for the fencing error I introduced in 4.0.4.
  * [745d5fe] Update Standards-Version to 3.9.8 (no changes needed)
  * [97c2659] New patch Enable-systemctl-help-dlm-to-show-relevant-man-
    pages.patch
  * [8b8406a] Automatic debug packages got rid of our overridden Lintian tag

 -- Ferenc Wágner <wferi@niif.hu>  Wed, 27 Apr 2016 12:16:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: dlm
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian HA Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
+Maintainer: Debian HA Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
 Uploaders: Ferenc Wágner <wferi@niif.hu>,
  Christoph Berg <myon@debian.org>
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9),
  dh-systemd,
  libcfg-dev (>= 1.99),
@@ -20,7 +19,7 @@
 Vcs-Git: https://anonscm.debian.org/git/debian-ha/dlm.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-ha/dlm.git/
 
-Package: dlm
+Package: dlm-controld
 Architecture: any
 Depends:
  corosync,

=== debian/rules ===
--- 
+++ 
@@ -17,8 +17,8 @@
 override_dh_auto_install:
 	dh_auto_install -- LIBNUM=/lib/$(DEB_HOST_MULTIARCH)
 
-DEFDIR=debian/dlm/etc/default
-SDDIR= debian/dlm/lib/systemd/system
+DEFDIR=debian/dlm-controld/etc/default
+SDDIR= debian/dlm-controld/lib/systemd/system
 override_dh_install:
 	dh_install --fail-missing
 	mkdir -p "$(DEFDIR)" "$(SDDIR)"

## dlm 4.0.7

=== dlm_controld/Makefile ===
--- 
+++ 
@@ -62,9 +62,9 @@
 LIB_LDFLAGS += -Wl,-z,relro -pie
 
 ifeq ($(USE_SD_NOTIFY),yes)
-	BIN_CFLAGS += $(shell pkg-config --cflags libsystemd-daemon) \
+	BIN_CFLAGS += $(shell pkg-config --cflags libsystemd) \
 		      -DUSE_SD_NOTIFY
-	BIN_LDFLAGS += $(shell pkg-config --libs libsystemd-daemon)
+	BIN_LDFLAGS += $(shell pkg-config --libs libsystemd)
 endif
 
 all: $(LIB_TARGET) $(BIN_TARGET)

=== dlm_tool/Makefile ===
DESTDIR=
PREFIX=/usr
BINDIR=$(PREFIX)/sbin
MANDIR=$(PREFIX)/share/man

BIN_TARGET = dlm_tool
MAN_TARGET = dlm_tool.8

BIN_SOURCE = main.c

BIN_CFLAGS += -D_GNU_SOURCE -O2 -ggdb \
	-Wall \
	-Wformat \
	-Wformat-security \
	-Wmissing-prototypes \
	-Wnested-externs \
	-Wpointer-arith \
	-Wextra -Wshadow \
	-Wcast-align \
	-Wwrite-strings \
	-Waggregate-return \
	-Wstrict-prototypes \
	-Winline \
	-Wredundant-decls \
	-Wno-sign-compare \
	-Wno-unused-parameter \
	-Wp,-D_FORTIFY_SOURCE=2 \
	-fexceptions \
	-fasynchronous-unwind-tables \
	-fdiagnostics-show-option \

BIN_CFLAGS += -fPIE -DPIE
BIN_CFLAGS += -I../include -I../libdlm -I../dlm_controld

BIN_LDFLAGS += -Wl,-z,now -Wl,-z,relro -pie
BIN_LDFLAGS += -L../libdlm -L../dlm_controld
BIN_LDFLAGS += -lpthread -ldlm -ldlmcontrol

all: $(BIN_TARGET)

$(BIN_TARGET): $(BIN_SOURCE)
	$(CC) $(BIN_SOURCE) $(BIN_CFLAGS) $(BIN_LDFLAGS) -o $@

clean:
	rm -f *.o *.so *.so.* $(BIN_TARGET)


INSTALL=$(shell which install)

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man8
	$(INSTALL) -c -m 755 $(BIN_TARGET) $(DESTDIR)/$(BINDIR)
	$(INSTALL) -m 644 $(MAN_TARGET) $(DESTDIR)/$(MANDIR)/man8/

=== debian/changelog ===
dlm (4.0.7-4) unstable; urgency=medium

  * [5063137] Add patch to fix cross build from source (Closes: #913866)

 -- Valentin Vidic <vvidic@debian.org>  Sun, 18 Nov 2018 10:02:59 +0100

dlm (4.0.7-3) unstable; urgency=medium

  * [a517b75] Add patch for gcc warning
  * [7af1126] Add patch to fix Makefile exit code (Closes: #911177)
  * [ff4c1c8] Update my email address in Uploaders
  * [fb72494] Update Standards-Version to 4.2.1
  * [36e9ac4] Add missing Build-Depends-Package to libdlmcontrol3.symbols

 -- Valentin Vidic <vvidic@debian.org>  Sun, 04 Nov 2018 19:01:58 +0100

dlm (4.0.7-2) unstable; urgency=medium

  * [3157881] Use pagure upstream instead of fedorahosted
  * [7fac16c] Use salsa repo instead of alioth
  * [376d06f] Update debhelper to v11
  * [3816de3] Fix gbp warnings in gbp.conf
  * [5145fca] Add patches for gcc warnings
  * [18c8c18] Add lintian override for AppStream warning
  * [582eb04] Add kmod to Depends
  * [6b24fa7] Add some simple autopkgtests
  * [a34f67c] Add myself to Uploaders
  * [7897617] Update Standards-Version to 4.1.4

 -- Valentin Vidic <Valentin.Vidic@CARNet.hr>  Thu, 26 Apr 2018 11:42:36 +0200

dlm (4.0.7-1) unstable; urgency=medium

  [ Christoph Berg ]
  * [9272a43] Remove Martin and myself from Uploaders.

  [ Ferenc Wágner ]
  * [3d39df9] DLM is Linux-only, don't try building on other architectures
  * [716e4e3] New upstream release (4.0.7)
  * [f5ffbae] Delete upstreamed patch, refresh the rest
  * [4dd6d43] Don't require the config file
  * [601dd41] Migrate to my Debian address
  * [d7953c9] General handling of CFLAGS, CPPFLAGS and LDFLAGS
  * [94735fd] New patch Don-t-link-dlm_stonith-against-libxml2.patch
  * [3744427] No need for --as-needed anymore

 -- Ferenc Wágner <wferi@debian.org>  Mon, 19 Dec 2016 23:53:33 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Debian HA Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
-Uploaders: Ferenc Wágner <wferi@niif.hu>,
- Christoph Berg <myon@debian.org>
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9),
- dh-systemd,
+Uploaders: Ferenc Wágner <wferi@debian.org>,
+ Valentin Vidic <vvidic@debian.org>
+Standards-Version: 4.2.1
+Build-Depends: debhelper (>= 11),
  libcfg-dev (>= 1.99),
  libcpg-dev (>= 1.99),
  libcmap-dev (>= 1.99),
@@ -15,14 +14,15 @@
  libstonithd-dev,
  libxml2-dev,
  pkg-config
-Homepage: https://fedorahosted.org/cluster/wiki/HomePage
-Vcs-Git: https://anonscm.debian.org/git/debian-ha/dlm.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-ha/dlm.git/
+Homepage: https://pagure.io/dlm
+Vcs-Browser: https://salsa.debian.org/ha-team/dlm
+Vcs-Git: https://salsa.debian.org/ha-team/dlm.git
 
 Package: dlm-controld
-Architecture: any
+Architecture: linux-any
 Depends:
  corosync,
+ kmod,
  ${misc:Depends},
  ${shlibs:Depends},
 # we're taking over /usr/sbin/dlm_{controld,tool}
@@ -38,7 +38,7 @@
 
 Package: libdlm3
 Section: libs
-Architecture: any
+Architecture: linux-any
 Multi-Arch: same
 Depends: ${shlibs:Depends},
  ${misc:Depends}
@@ -50,7 +50,7 @@
 
 Package: libdlm-dev
 Section: libdevel
-Architecture: any
+Architecture: linux-any
 Multi-Arch: same
 Depends: ${misc:Depends},
  libdlm3 (= ${binary:Version})
@@ -63,7 +63,7 @@
 
 Package: libdlmcontrol3
 Section: libs
-Architecture: any
+Architecture: linux-any
 Multi-Arch: same
 Depends: ${shlibs:Depends},
  ${misc:Depends}
@@ -75,7 +75,7 @@
 
 Package: libdlmcontrol-dev
 Section: libdevel
-Architecture: any
+Architecture: linux-any
 Multi-Arch: same
 Depends: ${misc:Depends},
  libdlmcontrol3 (= ${binary:Version})

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,10 @@
 # Ensure that we link against all needed libraries (cf. Policy 10.2)
 export DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,defs
 
-# Avoid useless dependencies in the utilities
-export DEB_LDFLAGS_MAINT_APPEND+=-Wl,--as-needed
-
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --with systemd
+	dh $@
 
 override_dh_auto_install:
 	dh_auto_install -- LIBNUM=/lib/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
https://releases.pagure.org/dlm/ dlm-(.*).tar.gz debian uupdate

## dlm 4.0.8

=== dlm_controld/Makefile ===
--- 
+++ 
@@ -31,40 +31,28 @@
              rbtree.c
 LIB_SOURCE = lib.c
 
-BIN_CFLAGS += -D_GNU_SOURCE -O2 -ggdb \
-	-Wall \
-	-Wformat \
-	-Wformat-security \
-	-Wmissing-prototypes \
-	-Wnested-externs \
-	-Wpointer-arith \
-	-Wextra -Wshadow \
-	-Wcast-align \
-	-Wwrite-strings \
-	-Waggregate-return \
-	-Wstrict-prototypes \
-	-Winline \
-	-Wredundant-decls \
-	-Wno-sign-compare \
-	-Wno-unused-parameter \
-	-Wp,-D_FORTIFY_SOURCE=2 \
-	-fexceptions \
-	-fasynchronous-unwind-tables \
-	-fdiagnostics-show-option \
+CFLAGS += -D_GNU_SOURCE -O2 -ggdb \
+	-Wall -Wformat -Wformat-security -Wmissing-prototypes -Wnested-externs \
+	-Wpointer-arith -Wextra -Wshadow -Wcast-align -Wwrite-strings \
+	-Waggregate-return -Wstrict-prototypes -Winline -Wredundant-decls \
+	-Wno-sign-compare -Wno-unused-parameter -Wp,-D_FORTIFY_SOURCE=2 \
+	-fexceptions -fasynchronous-unwind-tables -fdiagnostics-show-option \
+	-Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong \
+	-fstack-clash-protection -Wl,-z,now
 
-BIN_CFLAGS += -fPIE -DPIE
+BIN_CFLAGS += $(CFLAGS) -fPIE -DPIE
 BIN_CFLAGS += -I../include -I../libdlm
+LIB_CFLAGS += $(CFLAGS) -fPIC
 
-BIN_LDFLAGS += -Wl,-z,now -Wl,-z,relro -pie
+BIN_LDFLAGS += $(LDFLAGS) -Wl,-z,relro -pie
 BIN_LDFLAGS += -lpthread -lrt -lcpg -lcmap -lcfg -lquorum
+LIB_LDFLAGS += $(LDFLAGS) -Wl,-z,relro -pie
 
-LIB_CFLAGS += $(BIN_CFLAGS)
-LIB_LDFLAGS += -Wl,-z,relro -pie
-
+PKG_CONFIG ?= pkg-config
 ifeq ($(USE_SD_NOTIFY),yes)
-	BIN_CFLAGS += $(shell pkg-config --cflags libsystemd) \
+	BIN_CFLAGS += $(shell $(PKG_CONFIG) --cflags libsystemd) \
 		      -DUSE_SD_NOTIFY
-	BIN_LDFLAGS += $(shell pkg-config --libs libsystemd)
+	BIN_LDFLAGS += $(shell $(PKG_CONFIG) --libs libsystemd)
 endif
 
 all: $(LIB_TARGET) $(BIN_TARGET)
@@ -73,7 +61,7 @@
 	$(CC) $(BIN_SOURCE) $(BIN_CFLAGS) $(BIN_LDFLAGS) -o $@ -L.
 
 $(LIB_TARGET): $(LIB_SOURCE)
-	$(CC) $^ $(LIB_CFLAGS) $(LIB_LDFLAGS) -shared -fPIC -o $@ -Wl,-soname=$(LIB_SMAJOR)
+	$(CC) $^ $(LIB_CFLAGS) $(LIB_LDFLAGS) -shared -o $@ -Wl,-soname=$(LIB_SMAJOR)
 	ln -sf $(LIB_TARGET) $(LIB_SO)
 	ln -sf $(LIB_TARGET) $(LIB_SMAJOR)

=== debian/changelog ===
dlm (4.0.8-1) unstable; urgency=medium

  * [0f134dd] Upstream does not provide tarballs anymore
  * [948d36e] Switch to the merged Pacemaker dev package
  * [05d2feb] Update Standards-Version to 4.3.0
  * [79db167] Switch to dh_missing
  * [ad3febd] Bump Debhelper compat level to 12
  * [583193a] Refresh copyright years
  * [8b55e90] New upstream release (4.0.8)
  * [a7bb130] Delete upstreamed patches, refresh the rest (ordering problems
    reemerged!)
  * [3f917a6] The __DATE__ and __TIME__ macros are reproducible now in GCC

 -- Ferenc Wágner <wferi@debian.org>  Tue, 15 Jan 2019 15:26:46 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Debian HA Maintainers <debian-ha-maintainers@lists.alioth.debian.org>
 Uploaders: Ferenc Wágner <wferi@debian.org>,
  Valentin Vidic <vvidic@debian.org>
-Standards-Version: 4.2.1
-Build-Depends: debhelper (>= 11),
+Standards-Version: 4.3.0
+Build-Depends: debhelper (>= 12),
  libcfg-dev (>= 1.99),
  libcpg-dev (>= 1.99),
  libcmap-dev (>= 1.99),
  libquorum-dev (>= 1.99),
  libsystemd-dev,
- libstonithd-dev,
+ pacemaker-dev,
  libxml2-dev,
  pkg-config
 Homepage: https://pagure.io/dlm

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,10 @@
 DEFDIR=debian/dlm-controld/etc/default
 SDDIR= debian/dlm-controld/lib/systemd/system
 override_dh_install:
-	dh_install --fail-missing
+	dh_install
 	mkdir -p "$(DEFDIR)" "$(SDDIR)"
 	cp init/dlm.sysconfig "$(DEFDIR)"/dlm
 	cp init/dlm.service "$(SDDIR)"
+
+override_dh_missing:
+	dh_missing --fail-missing
